import { ModifyMode, Config } from './types';

const DEFAULT_CONFIG = { modifyMode: ModifyMode.SMART_APPEND, normalize: false, enforceNewLineEnd: true };

export function getDefaultConfig(customConfig?: Config): Config {
  return { ...DEFAULT_CONFIG, ...(customConfig || {})};
}

function findFirstDiffPos(a: string, b: string) {
  var i = 0;
  if (a === b) return -1;
  while (a[i] === b[i]) i++;
  return i;
}

export function compareWeighted(a: string, b: string): number {
  const diffPos = findFirstDiffPos(a, b);
  return a.localeCompare(b) * (diffPos > -1 ? diffPos + 1 : 1);
}
